<?php
# $Id: kernel.php,v 1.2 2003/01/05 13:05:40 pruet Exp $
# Kernel Agent
include "config.php";
include "global.php";
include "themes/$DefaultTheme";
if(AUTHORISE_REQUIRED == "true") {
	if(!isset($PHP_AUTH_USER) || ((strcmp(KEEPER_DB_USER,  $PHP_AUTH_USER) || strcmp(KEEPER_DB_PASS, $PHP_AUTH_PW)))) {
		header("WWW-Authenticate: Basic realm=\"WebMill Realm\"");
		header("HTTP/1.0 401 Unauthorized");
		echo "Sorry, you can't access this page.\n";
		exit;
	}
}
session_start();
define("KERNEL_VER", "0.0.2");
define("KERNEL_NAME", "kernel");
define("KERNEL_VER_TXT", "lalunis");
define("KERNEL_BACKEND_PATH", "back/");
class Message
{
	var $to;
	var $from;
	var $time;
	var $subject;
	var $header;
	var $content;
	function Message($nto = "", $nfrom = "", $nsubject = "")
	{
		$this->to = $nto;
		$this->from = $nfrom;
		$this->subject = $nsubject;
		$this->time = time();
		$this->header = array();
	}
	function set($nto = "", $nfrom = "", $nsubject = "")
	{
		$this->to = $nto;
		$this->from = $nfrom;
		$this->subject = $nsubject;
		$this->time = time();
	}
	function set_header($name, $value)
	{
		$this->header[$name] = $value;	
	}
	function get_header($name)
	{
		return($this->header[$name]);
	}
	function set_header_array($narray)
	{
		$this->header = array_merge($this->header, $narray);
	}
}
function send_message($mesg)
{
	if(!is_object($mesg)) {
		$mesg->subject = ERROR;
		$mesg->content = "You try to sent non-object message.";
		return $mesg;
	}
	if($mesg->to == "") {
		$mesg->subject = ERROR;
		$mesg->content = "You didn't specify the receiver.";
		return $mesg;
	}
	if($mesg->to == KERNEL_NAME) {
		if($mesg->subject == "contact") {
			if(is_array($mesg->content)) {
				$ar = $mesg->content;
				while(list($key, $val) = each($ar)) {
					$path = KERNEL_BACKEND_PATH . $val . ".php";
					include $path;
				}
			} else {
				$path = KERNEL_BACKEND_PATH . $mesg->content . ".php";
				include $path;
			}
		} elseif ($mesg->subject == "info") {
			$mesg->subject = OK;
			$mesg->content = "WebMill Kernel Module\n"
				. "Module Owner : Pruet Boonma <pruet@eng.cmu.ac.th>\n"
				. "Module Name : " . KERNEL_NAME . "\n"
				. "Module Version : " . KERNEL_VER . "\n"
				. "Module Code Name : " . KERNEL_VER_TXT . "\n"
				. "\n"
				. "Usage:\n"
				. "msg = new Message(\$receiver, \$sender, $subject )\n" 
				. "msg->set(\$receiver, \$sender, \$subject )\n"
				. "msg->set_header(\$name, \$value)\n"
				. "\$value = msg->get_header(\$name)\n"
				. "msg->set_header_array(\$array)\n"
				. "\n"
				. "Message:\n"
				. "[contact] Request another modules before used\n"
				. "[info] Request info (this information)\n"
				. "\n"
				. "Return subject:\n"
				. "[OK] everything seems to be good"
				. "[ERROR] something's wrong, look at content"
				. "\n"
				. "Todo:\n"
				. "Dynamic binding ?\n"
				. "\n"
				. "Known bug:\n"
				. "Tell me!!";
		} else {
			$mesg->subject = ERROR;
			$mesg->content = "I don't know what you want.";
		}
		$mesg->subject = OK;
		return $mesg;
	}
	$mill = strtoupper($mesg->to) . "_NAME";
	if(!defined($mill)) {
		$mesg->subject = ERROR;
		$mesg->content = "Can't find the receiver.";
		return $mesg;
	}
	$recv_mesg = strtoupper($mesg->to) . "_RECV_MESG";
	if(!defined($recv_mesg) && $recv_mesg) {
		$mesg->subject = ERROR;
		$mesg->content = "Receiver don't want to receive messages.";
	} else {
		$recv = $mesg->to . "_recv_mesg";
		$mesg = $recv($mesg);
		if($mesg->to == KERNEL) {
			debug(WARNING, KERNEL, $mesg->to);	
		}
	}
	return $mesg;
}
?>
