<?php
define("MP3STATION_VER", "0.1.0");
define("MP3STATION_RECV_MESG", TRUE);
define("MP3STATION_NAME", "mp3station");
define("MP3STATION_VER_TXT", "huggy");
define("MP3STATION_DB", DEFAULT_DB);
define("ALBUMLIST_TBL", "albumlist");
define("BANLIST_TBL", "banlist");
define("PLAYQUEUE_TBL", "playqueue");
define("SONGLIST_TBL", "songlist");
define("STATION_TBL", "station");     
define("REPEAT_TBL","repeat");

define("MP3_NO_ERROR", 0);
define("MP3_NO_USER_ID", 100);
define("MP3_NO_SONG_ID", 101);
define("MP3_DB_ERROR", 200);
define("MP3_MAX_IN_LIST", 300);
define("MP3_MAX_PER_PERSON", 301);
define("MP3_MAX_PER_ALBUM", 302);
define("MP3_READY_IN_LIST", 303);
define("MP3_NO_SONG", 304);
define("MP3_BANLIST", 400);
define("MP3_SESSION_ERROR", 401);
define("MP3_EMPTY_VALUE", 402);
define("MP3_USER_ERROR", 403);
define("MP3_PWD_ERROR", 404);
define("MP3_USER_EXIST", 405);
define("MP3_NO_RECV", 501); 

function TableUpdateTime() {
    $result=mysql_db_query(mp3,"show table status like 'albumlist'");
        $chek_row=mysql_fetch_array($result);
    $time = substr($chek_row[Update_time],0,10);
    setlocale (LC_TIME, "th_TH");
    ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $time, $datetime);
    $datetime = strftime("ѹ %d %B %Ey",mktime(0,0,0,$datetime[2],$datetime[3],$datetime[1]));
    $datetime = ucfirst($datetime);
    return $datetime;
}

function mp3station_destroy_db()
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "DROP TABLE " . ALBUMLIST_TBL . "," . BANLIST_TBL . ","
			. PLAYQUEUE_TBL . "," . SONGLIST_TBL . "," . STATION_TBL;
	return send_message($mesg);
}
function mp3station_init_db()
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "CREATE TABLE  " . ALBUMLIST_TBL . " ("
			. "album_id SERIAL PRIMARY KEY, "
			. "album_name varCHAR(255) NOT NULL, "
			. "title_name varCHAR(255) NOT NULL); ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "CREATE TABLE " . BANLIST_TBL . " ("
			. "banlist_id SERIAL PRIMARY KEY, "
			. "request_name varchar(255) NOT NULL )";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "CREATE TABLE " . PLAYQUEUE_TBL . " ("
			. "playqueue SERIAL PRIMARY KEY , "
			. "station_id int4 DEFAULT '0' NOT NULL, "
			. "song_id int8 DEFAULT '0' NOT NULL, "
			. "comment varchar(255) DEFAULT '' NOT NULL, "
			. "request_id int8 DEFAULT '0' NOT NULL, "
			. "status varchar(1) DEFAULT 'u'  NOT NULL)";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "CREATE TABLE " . SONGLIST_TBL . " ("
			. "song_id SERIAL PRIMARY KEY, "
			. "album_id int8 DEFAULT '0' NOT NULL, "
			. "song_name varchar(255) NOT NULL, "
			. "play_count int8 DEFAULT '0' NOT NULL, "
			. "request_count int8 DEFAULT '0' NOT NULL, "
			. "title_name varchar(255) NOT NULL, "
			. "UNIQUE (song_name)) ";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return $mesg;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "CREATE TABLE " . STATION_TBL . " ("
			. "station_id int8 DEFAULT '0' NOT NULL, "
			. "song_id int8 DEFAULT '0' NOT NULL, "
			. "station_name varchar(255) DEFAULT 'Online Radio Station' NOT NULL, "
			. "comment varchar(255) NOT NULL, "
			. "request_id int8 DEFAULT '0' NOT NULL, "
			. "PRIMARY KEY (station_id))";
	return send_message($mesg);
}

function mp3station_user_login($login, $password, $session, $host)
{
	$mesg = new Message(MANAGER_NAME, MP3STATION_NAME, "login");
	$mesg->set_header_array(array(
		"login" => $login,
		"password" => $password,
		"session" => $session,
		"host" => $host
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		switch($mesg->content) {
			case MNG_SESSION_ERROR :
				return MP3_SESSION_ERROR;
			case MNG_EMPTY_VALUE :
				return MP3_EMPTY_VALUE;
			case MNG_USER_ERROR :
				return MP3_USER_ERROR;
			default :
				return MP3_DB_ERROR;
		}
	}
	return MP3_NO_ERROR;
}
function mp3station_user_logout($session)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME,  "logout");
	$mesg->set_header("session", session_id());
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_EMPTY_VALUE;
	}
	return MP3_NO_ERROR;
}
function mp3station_user_new($login, $password, $repassword, $email, $name)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME, "user_add");
	$mesg->set_header_array(array(
		"login" => $login,
		"password" => $password,
		"repassword" => $repassword,
		"email" => $email,
		"name" => $name
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		switch($mesg->content) {
			case MNG_EMPTY_VALUE :
				return MP3_EMPTY_VALUE;
			case MNG_PWD_ERROR :
				return MP3_PWD_ERROR;
			case MNG_USER_EXIST :
				return MP3_USER_EXIST;
			default :
				return MP3_DB_ERROR;
		}
	}
	return MP3_NO_ERROR;
}
function mp3station_user_update($user_id, $login, $password, $repassword, $email, $name)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME, "user_update");
	$mesg->set_header_array(array(
		"user_id" => $user_id,
		"login" => $login,
		"password" => $password,
		"repassword" => $repassword,
		"email" => $email,
		"name" => $name
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		switch($mesg->content) {
			case MNG_EMPTY_VALUE :
				return MP3_EMPTY_VALUE;
			case MNG_PWD_ERROR :
				return MP3_PWD_ERROR;
			case MNG_USER_ERROR :
				return MP3_USER_ERROR;
			default :
				return MP3_DB_ERROR;
		}
	}
	return MP3_NO_ERROR;
}
function mp3station_check_session($session, $session_timeout)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME, "check");
	$mesg->set_header_array(array(
		"session" => $session,
		"timeout" => $session_timeout
	));
	$mesg = send_message($mesg);	
	if($mesg->subject != OK) {
		switch($mesg->content) {
			case MNG_EMPTY_VALUE :
				return MP3_EMPTY_VALUE;
			case MNG_USER_ERROR :
				return MP3_USER_ERROR;
			case MNG_TIME_OUT :
				return MP3_SESSION_ERROR;
			default :
				return MP3_DB_ERROR;
		} 
	}
	return MP3_NO_ERROR;
}
function mp3station_user_id(&$session)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME, "user_id");
	$mesg->set_header("session", $session);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		$session = "";
		switch($mesg->content) {
			case MNG_VALUE_EMPTY :
				return MP3_VALUE_EMPTY;
			case MNG_USER_ERROR :
				return MP3_USER_ERROR;
			default :
				return MP3_DB_ERROR;
		}
	}
	$session = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_user_info(&$user_id)
{
	$mesg = new Message(MANAGER_NAME, STATION_NAME, "user_info");
	$mesg->set_header("user_id", $user_id);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		switch($mesg->content) {
			case MNG_EMPTY_VALUE :
				return MP3_EMPTY_VALUE;
			case MNG_USER_ERROR :
				return MP3_USER_ERROR;
			default :
				return MP3_DB_ERROR;
		}
	}
	$user_id = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_song_request(&$song_id, $user_id, $user_host)
{
	if($user_id == "" || !is_integer($user_id)) {
		return MP3_NO_USER_ID;
	}
	if($song_id == "" || !is_integer($song_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$app_timestamp = time();
        $app_timeout = $app_timestamp - MAX_SONG_REPEAT;
	mysql_db_query(mp3,"DELETE FROM " . REPEAT_TBL. " WHERE timestamp < $app_timeout");
	$mesg->content = "select song_id from " . SONGLIST_TBL . " where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content == 0) {
		return MP3_NO_SONG;
	}

        $result=mysql_db_query(mp3,"select count(*) as count from " . REPEAT_TBL. " where song_id ='$song_id'");
        list($count)=mysql_fetch_row($result);
        if ($count != 0) {
                return MAX_SONG_REPEAT;
        }

	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select count(song_id) as song_count from " . PLAYQUEUE_TBL . " where ( " . PLAYQUEUE_TBL . ".status = 'u' and " . PLAYQUEUE_TBL . ".station_id = " . STATION_ID . ")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "song_count"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content >= MAX_SONG_IN_LIST) {
		return MP3_MAX_IN_LIST;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select album_id from " . SONGLIST_TBL . " where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "album_id"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$album_id = $mesg->content;
	if($album_id != 1 && $album_id != 2) {
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select count(album_id) as song_count from " . PLAYQUEUE_TBL . " left join " . SONGLIST_TBL . " using(song_id) where (playqueue.status='u' and songlist.album_id = $album_id and playqueue.station_id = " . STATION_ID. " )";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "song_count"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content >= MAX_SONG_PER_ALBUM) {
		return MP3_MAX_PER_ALBUM;
	}
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select count(song_id) as song_count from " . PLAYQUEUE_TBL . " where (playqueue.status = 'u' and playqueue.request_id = $user_id and playqueue.station_Id = " . STATION_ID. ")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "song_count"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content >= MAX_SONG_PER_PERSON) {
		return MP3_MAX_PER_PERSON;
	}
	$album_id = $mesg->content;
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select banlist_id from " . BANLIST_TBL . " where request_name like '%$user_host%'";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content != 0) {
		return MP3_BANLIST;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select song_id from " . PLAYQUEUE_TBL . " where (playqueue.status = 'u' and playqueue.song_id = $song_id and playqueue.station_id = " . STATION_ID . ")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content != 0) {
		return MP3_READY_IN_LIST;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "insert into " . PLAYQUEUE_TBL . " (song_id, request_id, station_id) values($song_id, $user_id, " . STATION_ID .")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "update " . SONGLIST_TBL . " set request_count = request_count + 1 where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->content = "select playqueue from " . PLAYQUEUE_TBL . " where song_id = $song_id and station_id = " . STATION_ID;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "playqueue"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$song_id = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_add_comment($song_id, $comment)
{
	if($song_id == "" || !is_integer($song_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "update " . PLAYQUEUE_TBL . " set comment = '" . pit($comment) . "' where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	return MP3_NO_ERROR;
}
function mp3station_song_search(&$song_name)
{
	if($song_name == "") {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
//	$mesg->content = "select song_id, song_name, title_name from " . SONGLIST_TBL . " where song_name like '%" . pit($song_name) . "%' order by lower(song_name)";

 	$mesg->content = "select song_id," . SONGLIST_TBL . ".song_name," . SONGLIST_TBL . ".title_name,".SONGLIST_TBL.".album_id, albumlist.album_name from " . SONGLIST_TBL . " left join " . ALBUMLIST_TBL . " using(album_id) where song_name like '%".pit($song_name)."%' or ".SONGLIST_TBL.".title_name like '%".pit($song_name)."%' order by lower(song_name) and " . ALBUMLIST_TBL .".album_id=" . SONGLIST_TBL . ".album_id";


	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK || $mesg->content == 0) {
		return MP3_NO_SONG;
	}
	$numrows = $mesg->content;
	$amesg = array();
	$emesg = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$emesg = array(
			"song_id" => $mesg->content[song_id],
			"song_name" => $mesg->content[song_name],
			"title_name" => $mesg->content[title_name],
			"album_id" => $mesg->content[album_id],
			"album_name" => $mesg->content[album_name],
		);
		$amesg[] = $emesg;
	}
	$song_name = $amesg;
	return MP3_NO_ERROR;
}
function mp3station_song_play(&$info)
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select comment, song_id, request_id from " . STATION_TBL . " where station_id = " . STATION_ID;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$info = $mesg->content;
	if($info[request_id] != "" && $info[request_id] != 0) {
		$uid = $mesg->content[request_id];
		$mesg->set(MANAGER_NAME, MP3STATION_NAME, "user_info");
		$mesg->set_header("user_id", $info[request_id]);
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$info = array_merge($info, $mesg->content);
		//$info[comment] = pot($info[comment]);
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	if($info[song_id] == "") {
		$info[song_id] = "1";
	}
 	$mesg->content = "select song_name, " . SONGLIST_TBL . ".title_name as song_title, " . ALBUMLIST_TBL . ".title_name, " . ALBUMLIST_TBL . ".album_name," . ALBUMLIST_TBL . ".album_id from " . SONGLIST_TBL . " left join " . ALBUMLIST_TBL . " using(album_id) where song_id = " . $info[song_id] ;
// apples Add Field album_name into $mesg->content 
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$info = array_merge($info, $mesg->content);
	return MP3_NO_ERROR;
}
function mp3station_show_list(&$info)
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select count(song_id) as num_song from " . PLAYQUEUE_TBL . " where (playqueue.status = 'u' and playqueue.station_id = " . STATION_ID . ")";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	if($mesg->content > 0) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "query");
		$mesg->content = "select " . SONGLIST_TBL . ".title_name, " . SONGLIST_TBL . ".song_name, " . PLAYQUEUE_TBL . ".request_id, "
			. PLAYQUEUE_TBL . ".comment from " . PLAYQUEUE_TBL . " left join " . SONGLIST_TBL . " using(song_id) "
			. " where (playqueue.status = 'u' and playqueue.station_id = " . STATION_ID . ") order by playqueue";
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$numrows = $mesg->content;
		$emesg = new Message("","","");
		for($i = 0; $i != $numrows; $i++) {
			$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
			$mesg = send_message($mesg);
			if($mesg->subject != OK) {
				return MP3_DB_ERROR;
			}
			$playqueue = $mesg->content[playqueue];
			$emesg->set(MANAGER_NAME, MP3STATION_NAME, "user_info");
			$emesg->set_header("user_id", $mesg->content[request_id]);
			$emesg = send_message($emesg);
			if($emesg->subject != OK) {
				return MP3_DB_ERROR;
			}
			//$emesg->content[comment] = pot($emesg->content[comment]);
			$info[$i] = array_merge($mesg->content, $emesg->content);
		}
	} else {
		return MP3_NO_SONG;
	}
	return MP3_NO_ERROR;
}
function mp3station_top_hit(&$info)
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
  	$mesg->content = "select song_id, " . ALBUMLIST_TBL . ".album_id, " . ALBUMLIST_TBL . ".album_name as album_title, " . SONGLIST_TBL . ".title_name, song_name from " . SONGLIST_TBL . " left join " . ALBUMLIST_TBL . " using(album_id) where request_count > 0 order by request_count desc limit " . MAX_TOP_HIT;
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$numrows = $mesg->content;
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$info[$i] = $mesg->content;
	}
	return MP3_NO_ERROR;
}
function mp3station_album_list(&$info)
{
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select album_id, album_name, title_name from " . ALBUMLIST_TBL . " order by lower(album_name)";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$numrows = $mesg->content;
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$info[$i] = $mesg->content;
	}
	return MP3_NO_ERROR;
}
function mp3station_album_name(&$album_id)
{
	if($album_id == "" || !is_integer($album_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select album_name from " . ALBUMLIST_TBL . " where album_id = $album_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "album_name"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$album_id = $mesg->content;
	return MP3_NO_ERROR;
}

function mp3station_album_id_from_song_id(&$song_id)
{
	if($song_id == "" || !is_integer($song_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select album_id from " . SONGLIST_TBL . " where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "album_id"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$song_id = $mesg->content;
	return MP3_NO_ERROR;
}

function mp3station_song_name(&$song_id)
{
	if($song_id == "" || !is_integer($song_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select title_name from " . SONGLIST_TBL . " where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "result");
	$mesg->set_header_array(array(
		"DBRow" => 0,
		"DBField" => "title_name"
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$song_id = $mesg->content;
	return MP3_NO_ERROR;
}

function mp3station_edit_album_name($album_id, $name)
{
	if($album_id == "" || !is_integer($album_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "update " . ALBUMLIST_TBL . " set title_name = '" . pit($name) . "' where album_id = $album_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	return MP3_NO_ERROR;
}

function mp3station_edit_song_name($song_id, $name)
{
	if($song_id == "" || !is_integer($song_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "update " . SONGLIST_TBL . " set title_name = '" . pit($name) . "' where song_id = $song_id";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	return MP3_NO_ERROR;
}

function mp3station_user_all(&$info)
{
	$mesg = new Message(MANAGER_NAME, MP3STATION_NAME, "num_all");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$info = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_user_online(&$info)
{
	$mesg = new Message(MANAGER_NAME, MP3STATION_NAME, "num_login");
	$mesg->set_header("timeout", $info);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$info = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_song_list(&$album_id)
{
	if($album_id == "" || !is_integer($album_id)) {
		return MP3_NO_SONG_ID;
	}
	$mesg = new Message(KEEPER_NAME, MP3STATION_NAME, "query");
	$mesg->set_header("DBName", MP3STATION_DB);
	$mesg->content = "select song_id, song_name, title_name from " . SONGLIST_TBL . " where album_id='$album_id' order by lower(song_name)";
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$mesg->set(KEEPER_NAME, MP3STATION_NAME, "numrows");
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		return MP3_DB_ERROR;
	}
	$numrows = $mesg->content;
	$album_id = array();
	for($i = 0; $i != $numrows; $i++) {
		$mesg->set(KEEPER_NAME, MP3STATION_NAME, "fetch");
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$album_id[$i] = $mesg->content;
	}
	return MP3_NO_ERROR;
}
function mp3station_mesg_check(&$user_id)
{
	if($user_id == "" || !is_integer($user_id)) {
		return MP3_NO_USER_ID;
	}
	$mesg = new Message(MESSAGER_NAME, MP3STATION_NAME, "check");
	$mesg->set_header("receiver", $user_id);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		if($mesg->content == MSG_NO_USER_ID) {
			return MP3_NO_USER_ID;
		}
		return MP3_DB_ERROR;
	}
	$user_id = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_mesg_list(&$user_id)
{
	if($user_id == "" || !is_integer($user_id)) {
		return MP3_NO_USER_ID;
	}
	$mesg = new Message(MESSAGER_NAME, MP3STATION_NAME, "get_all");
	$mesg->set_header("receiver", $user_id);
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		if($mesg->content = MSG_NO_USER_ID) {
			return MP3_NO_USER_ID;
		}
		return MP3_DB_ERROR;
	}
	$user_id = $mesg->content;
	return MP3_NO_ERROR;
}
function mp3station_mesg_send($user_id, $recv_id, $subject, $content)
{
	if($user_id == "" || !is_integer($user_id)) {
		return MP3_NO_USER_ID;
	}
	if(!is_integer($recv_id)) {
		$mesg = new Message(MANAGER_NAME, MP3STATION_NAME, "user_info");
		$mesg->set_header("login", $recv_id);
		$mesg = send_message($mesg);
		if($mesg->subject != OK) {
			return MP3_DB_ERROR;
		}
		$recv_id = $mesg->content[user_id];
	}
	if($subject == "") {
		$subject  = "No subject";
	}
	$mesg = new Message(MESSAGER_NAME, MP3STATION_NAME, "send");
	$mesg->content = $content;
	$mesg->set_header_array(array(
		"sender" => $user_id,
		"receiver" => $recv_id,
		"subject" => $subject
	));
	$mesg = send_message($mesg);
	if($mesg->subject != OK) {
		if($mesg->content = MSG_NO_USER_ID) {
			return MP3_USER_ERROR;
		}
		return MP3_DB_ERROR;
	}
	return MP3_NO_ERROR;
}
function mp3station_recv_mesg($mesg)
{
	$result = new Message($mesg->from, MANAGER, OK);
	switch($mesg->subject) {
		case "init_db" :
			$result = mp3station_init_db();
			break;
		case "destroy_db" :
			$result = mp3station_destroy_db();
			break;      
		default :
			$result->content = MNG_UNKNOW_CMD;
			$result->subject = ERROR;
			debug(ERROR, MANAGER_NAME, $result->content);
	}
	return $result;    
}
?>
