<?php
# $Id: keeper.php,v 1.1.1.1 2003/01/03 10:42:07 pruet Exp $
# Data Keeper : Database Dependent Agent

define("KEEPER_VER", "0.0.1");
define("KEEPER_NAME", "keeper");
define("KEEPER_RECV_MESG", TRUE);
define("KPR_QUERY_ERROR", 100);
define("KPR_INSERT_ID", 101);

include("back/db/" . KEEPER_DB . ".php");
function keeper_recv_mesg($mesg)
{
	switch ($mesg->subject) {
		case "query" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			$rst = $db->query($mesg->content);
			if(!$rst) {
				$mesg->subject = ERROR;
				$mesg->set_header("DBMessage",$db->error());
				$mesg->content = KPR_QUERY_ERROR;
				debug(ERROR, KEEPER_NAME, $mesg->content);
				return $mesg;
			}
			$mesg->set_header("DBResult", $rst);
			break;
		case "insert" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			if(!DB_INSERT_ID) {
				$mesg->subject = ERROR;
				$mesg->content = KPR_INSERT_ID;
				debug(ERROR, KEEPER_NAME, $mesg->content);
				return $mesg;
			} else {
				$id = $db->insert($mesg->content);
				if(!$id) {
					$mesg->subject = ERROR;
					$mesg->set_header("DBMEssage", $db->error());
					$mesg->content = "Can't insert.";
					debug(ERROR, KEEPER_NAME, $mesg->content);
					return $mesg;
				} else {
					$mesg->content = "$id";
				}
			}
			break;
		case "numrows" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			$mesg->content = $db->numrows($mesg->get_header("DBResult"));	
			break;
		case "result" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			$mesg->content = $db->result($mesg->get_header("DBResult"), $mesg->get_header("DBRow"), $mesg->get_header("DBField"));
			break;
		case "fetch" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			$mesg->content = $db->fetch($mesg->get_header("DBResult"));
			break;
		case "search" :
			$db = new Database(KEEPER_DB_HOST, KEEPER_DB_PORT, KEEPER_DB_USER, KEEPER_DB_PASS, $mesg->get_header("DBName"));
			$flag = $db->seek($mesg->get_header("DBResult"), 0);
			if($flag) {
				$flag = FALSE;
				$rsst = $mesg->get_header("DBResult");
				$field = $mesg->get_header("field");
				$value = $mesg->content;
				while($row = $db->fetch($rsst)) {
					if($row[$field] == $value) {
						$mesg->content = $row;
						$flag = TRUE;
						break;
					}
				}
				if(!$flag) {
					$mesg->subject = WARNING;
					$mesg->content = "Not found";
					debug(WARNING, KEEPER_NAME, $mesg->content);
				}
			} else {
				$mesg->subject = WARNING;
				$mesg->content = "Empy mesg set.";
				debug(WARNING, KEEPER_NAME, $mesg->content);
			}
			break;
		default :
			$mesg->content = "Unknow command [" . $mesg->subject . "]";
			$mesg->subject = ERROR;
			debug(ERROR, KEEPER_NAME, $mesg->content);
	}
	$mesg->subject = OK;
	return $mesg;
}
